Description

Some `assert_select` in the tests have wrong argument format. For example, the code at 

source:trunk/test/functional/timelog_report_test.rb@22254#L113 should be fixed as follows.

current wrong code:

assert_select 'td.name a.user.active[href=?]', '/users/1', 1, :text => 'Redmine Admin'

 fixed code:

assert_select 'td.name a.user.active[href=?]', '/users/1', :text => 'Redmine Admin', :count => 1

 The current code probably be intended to check if there is one matching td.name a.user.active[href=/users/1] with text "Redmine

Admin", but assert_select recognizes the last argument :text => 'Redmine Admin' as a assertion message. As a result, the link text

never been checked.

In Rails::Dom::Testing version 2.1.0 and later checks this kind of mistakes and raises ArgumentError.

Raise an error if the last arg is the wrong format by ghiculescu · Pull Request #96 · rails/rails-dom-testing · GitHub

Error:

TimelogReportTest#test_report_should_show_locked_users:

ArgumentError: Last argument was a Hash, which would be used for the assertion message. You probab

ly want this to be a String, or you have the wrong type of arguments.

    test/functional/timelog_report_test.rb:113:in `test_report_should_show_locked_users'

rails test test/functional/timelog_report_test.rb:103

 The attached patch fixes wrong usages of assert_select.

Associated revisions

Revision 22273 - 2023-07-02 08:34 - Go MAEDA

Fix incorrect argument format for assert_select that causes ArgumentError with rails-dom-testing >= 2.1.0 (#38797).

Patch by Go MAEDA.

Revision 22274 - 2023-07-02 08:44 - Go MAEDA

Merged r22273 from trunk to 5.0-stable (#38797).

Revision 22275 - 2023-07-02 08:53 - Go MAEDA

Merged r22273 from trunk to 4.2-stable (#38797).

History

#1 - 2023-07-02 08:53 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed
https://www.redmine.org/projects/redmine/repository/svn/revisions/22254/entry/trunk/test/functional/timelog_report_test.rb#L113
https://github.com/rails/rails-dom-testing/pull/96


Committed the patch.

#2 - 2023-07-04 08:43 - Vincent Robert

I was wondering what caused all the automated tests to suddenly turn red on Redmine 4.2.10.

Thank you for addressing this problem and resolving it in the upcoming release.

Files

fix-wrong-usages-of-assert_select.patch 5.11 KB 2023-07-02 Go MAEDA
